/*
 * Copyright (C)
 * Author:
 * License:
 */

#include <mockturtle-framework.h>

enum rt_slot_name {
	HELLOFRM_CMD_IN = 0,
	HELLOFRM_CMD_OUT,
};

static struct rt_mq mq[] = {
	[HELLOFRM_CMD_IN] = {
		.index = 0,
		.flags = TRTL_RT_MQ_FLAGS_HMQ | TRTL_RT_MQ_FLAGS_INPUT,
	},
	[HELLOFRM_CMD_OUT] = {
		.index = 0,
		.flags = TRTL_RT_MQ_FLAGS_HMQ | TRTL_RT_MQ_FLAGS_OUTPUT,
	},
};

static struct rt_application app = {
	.name = "hellofrm",
	.version = {
		.fpga_id = CONFIG_FPGA_APPLICATION_ID,
		.rt_id = CONFIG_RT_APPLICATION_ID,
		.rt_version = RT_VERSION(0, 1),
		.git_version = GIT_VERSION
	},
	.mq = mq,
	.n_mq = ARRAY_SIZE(mq),
};

/**
 * Well, the main :)
 */
int main()
{
	rt_init(&app);

	while (1) {
		/*
		 * Handle all messages incoming from slot
		 * HELLOFRM_CMD_IN
		 * as actions
		 */
		rt_mq_action_dispatch(HELLOFRM_CMD_IN);
	}

	return 0;
}
