---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for Mock Turtle CPU Control/Status registers block
---------------------------------------------------------------------------------------
-- File           : mt_cpu_csr_wbgen2_pkg.vhd
-- Author         : auto-generated by wbgen2 from mt_cpu_csr.wb
-- Created        : Tue Apr  3 10:41:22 2018
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE mt_cpu_csr.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

package mt_cpu_csr_wbgen2_pkg is
  
  
  -- Input registers (user design -> WB slave)
  
  type t_mt_cpu_csr_in_registers is record
    app_id_i                                 : std_logic_vector(31 downto 0);
    int_i                                    : std_logic_vector(7 downto 0);
    core_count_i                             : std_logic_vector(3 downto 0);
    core_memsize_i                           : std_logic_vector(31 downto 0);
    udata_i                                  : std_logic_vector(31 downto 0);
    dbg_msg_data_i                           : std_logic_vector(7 downto 0);
    dbg_poll_ready_i                         : std_logic_vector(7 downto 0);
    hmqi_status_lo_i                         : std_logic_vector(31 downto 0);
    hmqi_status_hi_i                         : std_logic_vector(31 downto 0);
    hmqo_status_lo_i                         : std_logic_vector(31 downto 0);
    hmqo_status_hi_i                         : std_logic_vector(31 downto 0);
    dbg_cpu_status_i                         : std_logic_vector(7 downto 0);
    dbg_cpu_insn_ready_i                     : std_logic_vector(7 downto 0);
    dbg_mbx0_i                               : std_logic_vector(31 downto 0);
    dbg_mbx1_i                               : std_logic_vector(31 downto 0);
    end record;
  
  constant c_mt_cpu_csr_in_registers_init_value: t_mt_cpu_csr_in_registers := (
    app_id_i => (others => '0'),
    int_i => (others => '0'),
    core_count_i => (others => '0'),
    core_memsize_i => (others => '0'),
    udata_i => (others => '0'),
    dbg_msg_data_i => (others => '0'),
    dbg_poll_ready_i => (others => '0'),
    hmqi_status_lo_i => (others => '0'),
    hmqi_status_hi_i => (others => '0'),
    hmqo_status_lo_i => (others => '0'),
    hmqo_status_hi_i => (others => '0'),
    dbg_cpu_status_i => (others => '0'),
    dbg_cpu_insn_ready_i => (others => '0'),
    dbg_mbx0_i => (others => '0'),
    dbg_mbx1_i => (others => '0')
    );
    
    -- Output registers (WB slave -> user design)
    
    type t_mt_cpu_csr_out_registers is record
      reset_o                                  : std_logic_vector(7 downto 0);
      int_o                                    : std_logic_vector(7 downto 0);
      int_load_o                               : std_logic;
      uaddr_addr_o                             : std_logic_vector(19 downto 0);
      core_sel_o                               : std_logic_vector(3 downto 0);
      udata_o                                  : std_logic_vector(31 downto 0);
      udata_load_o                             : std_logic;
      dbg_imsk_enable_o                        : std_logic_vector(7 downto 0);
      smem_op_o                                : std_logic_vector(2 downto 0);
      hmq_sel_o                                : std_logic_vector(5 downto 0);
      dbg_cpu_force_o                          : std_logic_vector(7 downto 0);
      dbg_cpu0_insn_o                          : std_logic_vector(31 downto 0);
      dbg_cpu0_insn_wr_o                       : std_logic;
      dbg_cpu1_insn_o                          : std_logic_vector(31 downto 0);
      dbg_cpu1_insn_wr_o                       : std_logic;
      dbg_mbx0_o                               : std_logic_vector(31 downto 0);
      dbg_mbx0_load_o                          : std_logic;
      dbg_mbx1_o                               : std_logic_vector(31 downto 0);
      dbg_mbx1_load_o                          : std_logic;
      end record;
    
    constant c_mt_cpu_csr_out_registers_init_value: t_mt_cpu_csr_out_registers := (
      reset_o => (others => '0'),
      int_o => (others => '0'),
      int_load_o => '0',
      uaddr_addr_o => (others => '0'),
      core_sel_o => (others => '0'),
      udata_o => (others => '0'),
      udata_load_o => '0',
      dbg_imsk_enable_o => (others => '0'),
      smem_op_o => (others => '0'),
      hmq_sel_o => (others => '0'),
      dbg_cpu_force_o => (others => '0'),
      dbg_cpu0_insn_o => (others => '0'),
      dbg_cpu0_insn_wr_o => '0',
      dbg_cpu1_insn_o => (others => '0'),
      dbg_cpu1_insn_wr_o => '0',
      dbg_mbx0_o => (others => '0'),
      dbg_mbx0_load_o => '0',
      dbg_mbx1_o => (others => '0'),
      dbg_mbx1_load_o => '0'
      );
    function "or" (left, right: t_mt_cpu_csr_in_registers) return t_mt_cpu_csr_in_registers;
    function f_x_to_zero (x:std_logic) return std_logic;
    function f_x_to_zero (x:std_logic_vector) return std_logic_vector;
end package;

package body mt_cpu_csr_wbgen2_pkg is
function f_x_to_zero (x:std_logic) return std_logic is
begin
if x = '1' then
return '1';
else
return '0';
end if;
end function;
function f_x_to_zero (x:std_logic_vector) return std_logic_vector is
variable tmp: std_logic_vector(x'length-1 downto 0);
begin
for i in 0 to x'length-1 loop
if(x(i) = 'X' or x(i) = 'U') then
tmp(i):= '0';
else
tmp(i):=x(i);
end if; 
end loop; 
return tmp;
end function;
function "or" (left, right: t_mt_cpu_csr_in_registers) return t_mt_cpu_csr_in_registers is
variable tmp: t_mt_cpu_csr_in_registers;
begin
tmp.app_id_i := f_x_to_zero(left.app_id_i) or f_x_to_zero(right.app_id_i);
tmp.int_i := f_x_to_zero(left.int_i) or f_x_to_zero(right.int_i);
tmp.core_count_i := f_x_to_zero(left.core_count_i) or f_x_to_zero(right.core_count_i);
tmp.core_memsize_i := f_x_to_zero(left.core_memsize_i) or f_x_to_zero(right.core_memsize_i);
tmp.udata_i := f_x_to_zero(left.udata_i) or f_x_to_zero(right.udata_i);
tmp.dbg_msg_data_i := f_x_to_zero(left.dbg_msg_data_i) or f_x_to_zero(right.dbg_msg_data_i);
tmp.dbg_poll_ready_i := f_x_to_zero(left.dbg_poll_ready_i) or f_x_to_zero(right.dbg_poll_ready_i);
tmp.hmqi_status_lo_i := f_x_to_zero(left.hmqi_status_lo_i) or f_x_to_zero(right.hmqi_status_lo_i);
tmp.hmqi_status_hi_i := f_x_to_zero(left.hmqi_status_hi_i) or f_x_to_zero(right.hmqi_status_hi_i);
tmp.hmqo_status_lo_i := f_x_to_zero(left.hmqo_status_lo_i) or f_x_to_zero(right.hmqo_status_lo_i);
tmp.hmqo_status_hi_i := f_x_to_zero(left.hmqo_status_hi_i) or f_x_to_zero(right.hmqo_status_hi_i);
tmp.dbg_cpu_status_i := f_x_to_zero(left.dbg_cpu_status_i) or f_x_to_zero(right.dbg_cpu_status_i);
tmp.dbg_cpu_insn_ready_i := f_x_to_zero(left.dbg_cpu_insn_ready_i) or f_x_to_zero(right.dbg_cpu_insn_ready_i);
tmp.dbg_mbx0_i := f_x_to_zero(left.dbg_mbx0_i) or f_x_to_zero(right.dbg_mbx0_i);
tmp.dbg_mbx1_i := f_x_to_zero(left.dbg_mbx1_i) or f_x_to_zero(right.dbg_mbx1_i);
return tmp;
end function;
end package body;
