/**
 * @defgroup framework-variable Framework Variable
 * @{
 * @ingroup framework
 * @brief Variable exchange mechanism
 * @copyright (C) 2015-2016 CERN (www.cern.ch)
 * @author Federico Vaga <federico.vaga@cern.ch>
 *
 * SPDX-License-Identifier: MPL-2.0
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#ifndef __TRTL_FW_FRM_VARIABLE_H__
#define __TRTL_FW_FRM_VARIABLE_H__

/**
 * Variable flag. Register
 */
#define TRTL_RT_VARIABLE_FLAG_FLD (1 << 0)

/**
 * Description of a variable that we want to export to the external
 * world (host or network).
 */
struct rt_variable {
	void *addr; /**< variable address */
	uint32_t mask; /**< variable mask without offset applied */
	uint8_t offset; /**< variable offset within the word */
	uint32_t flags; /**< variable options */
};

#endif
/**@}*/
