/*
 * Copyright (C) 2013-2016 CERN (www.cern.ch)
 * Author: Tomasz Wlostowski <tomasz.wlostowski@cern.ch>
 * Author: Federico Vaga <federico.vaga@cern.ch>
 * SPDX-License-Identifier: MPL-2.0
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 */

#include <stdio.h>
#include <stdint.h>
#include <string.h>

#include "mockturtle-rt-common.h"

int putchar(int c)
{
	lr_writel(c, MT_CPU_LR_REG_DBG_CHR);

	return 0;
}


/**
 * It sends a string over the serial interface
 * @param[in] p string to send
 * @return number of sent characters
 *
 * The function does not add any special character.
 * If you neeed the new-line or the carriage-return
 * you have to add them to your strings.
 */
int puts(const char *p)
{
	const char *p_orig = p;
	char c;

	while ((c = *(p++)))
		putchar (c);

	return p - p_orig;
}
