import os
import PyMockTurtle
import pytest

@pytest.fixture(scope="module")
def devid():
    return 0x1

@pytest.fixture(scope="module")
def cfg():
    cfg = PyMockTurtle.TrtlConfig()
    cfg.signature = PyMockTurtle.TrtlConfig.TRTL_CONFIG_ROM_SIGNATURE
    cfg.version = 0
    cfg.pad = 0
    cfg.clock_freq = 0
    cfg.flags = 0
    cfg.app_id = 0xd330d330
    cfg.n_cpu = 2
    cfg.smem_size = 0x00002000
    cfg.hmq_width = 0
    return cfg

@pytest.fixture(scope="module", params=range(cfg().n_cpu))
def cpu_idx(request):
    return request.param


@pytest.fixture(scope="module", params=[0x1])
def trtl_device(request):
    dev = PyMockTurtle.TrtlDevice(request.param)
    return dev

@pytest.fixture(scope="module", params=range(cfg().n_cpu))
def trtl_cpu(request):
    dev = PyMockTurtle.TrtlDevice(devid())
    yield dev.cpu[request.param]
    dev.cpu[request.param].disable()

@pytest.fixture(scope="module")
def trtl_shm():
    dev = PyMockTurtle.TrtlDevice(devid())
    return dev.shm

@pytest.fixture(scope="module")
def trtl_hmq():
   dev = PyMockTurtle.TrtlDevice(devid())
   return dev
